﻿local L = AceLibrary("AceLocale-2.2"):new("Automaton_Unshapeshift")
Automaton_Unshapeshift = Automaton:NewModule("Unshapeshift", "AceEvent-2.0", "AceDebug-2.0")
local module = Automaton_Unshapeshift

L:RegisterTranslations("enUS", function() return {
    ["Unshapeshift"] = true,
	["Automatically unshapeshift when you receieve ui errors about being shapeshifted"] = true,
	["Shaman"] = true,
	["Ghost Wolf"] = true,
	["Priest"] = true,
	["Shadowform"] = true,
	["Druid"] = true,
} end)

L:RegisterTranslations("koKR", function() return {
    ["Unshapeshift"] = "변신",
	["Automatically unshapeshift when you receieve ui errors about being shapeshifted"] = "변신 상태의 행동 불능 오류시 변신 상태를 해제합니다.",
	["Shaman"] = "주술사",
	["Ghost Wolf"] = "늑대 정령",
	["Priest"] = "사제",
	["Shadowform"] = "어둠의 형상",
	["Druid"] = "드루이드",
} end)

L:RegisterTranslations("esES", function() return {
    ["Unshapeshift"] = "Cambio de Forma",
	["Automatically unshapeshift when you receieve ui errors about being shapeshifted"] = "Cancela tu cambio de forma autom\195\161ticamente cuando recibes errores sobre estar en cambio de forma",
	["Shaman"] = "Cham\195\161n",
	["Ghost Wolf"] = "Lobo fantasmal",
	["Priest"] = "Sacerdote",
	["Shadowform"] = "Forma de las Sombras",
	["Druid"] = "Druid",
} end)

L:RegisterTranslations("zhTW", function() return {
["Unshapeshift"] = "解除形態",
["Automatically unshapeshift when you receieve ui errors about being shapeshifted"] = "當收到系統提示'處于某種形態'時自動解除形態",
["Shaman"] = "薩滿",
["Ghost Wolf"] = "幽魂之狼",
["Priest"] = "牧師",
["Shadowform"] = "暗影形態",
["Druid"] = "德魯依",
} end)

module.description = L["Automatically unshapeshift when you receieve ui errors about being shapeshifted"]
module.options = {}

function module:OnInitialize()
	self:RegisterOptions(self.options)
end

function module:OnEnable()
	self:RegisterEvent("UI_ERROR_MESSAGE")
	if UnitClass("player") == L["Druid"] or UnitClass("player") == L["Shaman"] then
		self:RegisterEvent("TAXIMAP_OPENED")
	end
end

local messages = {
	[ERR_CANT_INTERACT_SHAPESHIFTED] = true,
	[ERR_NOT_WHILE_SHAPESHIFTED] = true,
	[SPELL_FAILED_NOT_SHAPESHIFT] = true,
	[SPELL_FAILED_ONLY_UNDERWATER] = true,
	[ERR_NO_ITEMS_WHILE_SHAPESHIFTED] = true,
	[SPELL_FAILED_NO_ITEMS_WHILE_SHAPESHIFTED] = true,
	[ERR_MOUNT_SHAPESHIFTED] = true,
}

function module:UI_ERROR_MESSAGE(msg)
	if UnitClass("player") == L["Priest"] and msg == messages[ERR_CANT_INTERACT_WHILE_SHAPESHIFTED] then return end
	if messages[msg] then
		self:Unshapeshift()
	end
end

function module:TAXIMAP_OPENED()
	self:Unshapeshift(true)
end

function module:Unshapeshift(really)
	for i=1,GetNumShapeshiftForms() do
		local _,name, active = GetShapeshiftFormInfo(i)
		if active and (really or not (name == "Flight Form")) then
			CastShapeshiftForm(i)
			return true
		end
	end
	if UnitClass("player") == L["Shaman"] then
		CancelPlayerBuff(L["Ghost Wolf"])
	elseif UnitClass("player") == L["Priest"] then
		CancelPlayerBuff(L["Shadowform"])
	end
end